/*
 *  cjogame.c
 *  Othello
 *
 *  Created by Curtis Jones on 2010.09.27.
 *  Copyright 2010 __MyCompanyName__. All rights reserved.
 *
 */

#include "cjogame.h"
#include "cjoboard.h"
#include "logger.h"
#include <string.h>

#pragma mark -
#pragma mark Structors

/**
 *
 *
 */
int
cjogame_init (cjogame_t *game)
{
	if (unlikely(game == NULL))
		LOG_ERROR_AND_RETURN(-1, "null cjogame_t");
	
	// zero out the game memory
	memset(game, 0, sizeof(cjogame_t));
	
	// initialize our game board with the standard starting configuration
	cjoboard_init(&game->board);
	
	// white gets to go first
	game->player = CJO_STATE_WHITE;
	
	return 0;
}

/**
 *
 *
 */
int
cjogame_play (cjogame_t *game, cjospace_t space)
{
	int wins=0, xplaycnt=0;
	
	if (unlikely(game == NULL))
		LOG_ERROR_AND_RETURN(-1, "null cjogame_t");
	
	// make the play and store the number of "wins" achieved by the play
	wins = cjoboard_play(&game->board, space, game->player);
	
	// find the number of legal plays available to the opponent
	xplaycnt = cjoboard_playcnt(&game->board, CJO_XSTATE(game->player));
	
	// if the opponent has at least one legal play available, switch players
	if (xplaycnt > 0)
		game->player = CJO_XSTATE(game->player);
	
	return wins;
}

/**
 * TODO: implement
 *
 * 4, 3, 4, 2, 7, 7, 5, 6, 4, 11, 5, 9
 *
 */
cjospace_t
cjogame_analyze (cjogame_t *game)
{
	// does the move take a corner?
	
	// does the move take edge (ie, "A" ring) pieces?
	//   how many?
	
	// is this a "B" ring move?
	//   this is bad
	
	// is this a "C" ring move?
	//   this is good
	
	// diagonals are better than straights
	
	// more pieces are better than fewer pieces
	
	// prevent opponent from
	//   taking corners
	//   taking edge pieces
	//   making diagonal moves
	//   taking many pieces
	
	
	
	// for each available play
	//   ...
	
	
	
	return CJO_SPACE_A1;
}
